# Polyester

[![Stable](https://img.shields.io/badge/docs-stable-blue.svg)](https://JuliaSIMD.github.io/Polyester.jl/stable)
[![Dev](https://img.shields.io/badge/docs-dev-blue.svg)](https://JuliaSIMD.github.io/Polyester.jl/dev)
[![CI](https://github.com/JuliaSIMD/Polyester.jl/actions/workflows/CI.yml/badge.svg)](https://github.com/JuliaSIMD/Polyester.jl/actions/workflows/CI.yml)
[![CI-Nightly](https://github.com/JuliaSIMD/Polyester.jl/actions/workflows/CI-julia-nightly.yml/badge.svg)](https://github.com/JuliaSIMD/Polyester.jl/actions/workflows/CI-julia-nightly.yml)
[![Coverage](https://codecov.io/gh/JuliaSIMD/Polyester.jl/branch/master/graph/badge.svg)](https://codecov.io/gh/JuliaSIMD/Polyester.jl)

Polyester.jl provides **low-overhead multithreading** in Julia. The primary API is `@batch`, which can be used to parallelize for-loops (similar to `@threads`).

Polyester implements static scheduling (c.f. `@threads :static`) and has minimal overhead because it manages and re-uses a dedicated set of Julia tasks. This can lead to (great) speedups compared to other multithreading variants (see [Benchmark]() below).

## Basic usage example

```julia
using Polyester

function axpy_polyester!(y, a, x)
    @batch for i in eachindex(y,x)
        y[i] = a * x[i] + y[i]
    end
end

a = 3.141
x = rand(10_000)
y = rand(10_000)
axpy_polyester!(y, a, x)
```

## Important Notes

* `Polyester.@batch` moves arrays to threads by turning them into [StrideArraysCore.PtrArray](https://github.com/JuliaSIMD/StrideArraysCore.jl)s. This means that under an `@batch` slices will create `view`s by default(!). You may want to start Julia with `--check-bounds=yes` while debugging.

* Polyester uses the regular Julia threads. The total number of threads is still governed by [`--threads` or `JULIA_NUM_THREADS`](https://docs.julialang.org/en/v1.6/manual/multi-threading/#Starting-Julia-with-multiple-threads) (check with `Threads.nthreads()`).

* Polyester **does not** pin Julia threads to CPU-cores/threads. You can control how many "Polyester tasks" you want to use (see below). But to ensure that these tasks are running on specific CPU-cores/threads, you need to use a tool like [ThreadPinning.jl](https://github.com/carstenbauer/ThreadPinning.jl).

## Simple benchmark

Let's consider a basic [axpy](https://en.wikipedia.org/wiki/Basic_Linear_Algebra_Subprograms#Level_1) kernel.

```julia
using Polyester: @batch
using Base.Threads: @threads
using LinearAlgebra
using BenchmarkTools

# pinning threads for good measure
using ThreadPinning
pinthreads(:cores)

# Single threaded.
function axpy_serial!(y, a, x)
    for i in eachindex(y,x)
        @inbounds y[i] = a * x[i] + y[i]
    end
end

# Multithreaded with @batch
function axpy_batch!(y, a, x)
    @batch for i in eachindex(y,x)
        @inbounds y[i] = a * x[i] + y[i]
    end
end

# Multithreaded with @threads (default scheduling)
function axpy_atthreads!(y, a, x)
    @threads for i in eachindex(y,x)
        @inbounds y[i] = a * x[i] + y[i]
    end
end

# Multithreaded with @threads :static
function axpy_atthreads_static!(y, a, x)
    @threads :static for i in eachindex(y,x)
        @inbounds y[i] = a * x[i] + y[i]
    end
end

y = rand(10_000);
x = rand(10_000);
@benchmark axpy_serial!($y, eps(), $x)
@benchmark axpy_batch!($y, eps(), $x)
@benchmark axpy_atthreads!($y, eps(), $x)
@benchmark axpy_atthreads_static!($y, eps(), $x)
@benchmark axpy!(eps(), $x, $y) # BLAS built-in axpy
VERSION
```

With 8 Julia threads (pinned to different CPU-cores) I find the following results.

```julia
julia> @benchmark axpy_serial!($y, eps(), $x)
BenchmarkTools.Trial: 10000 samples with 10 evaluations.
 Range (min … max):  1.430 μs …  2.226 μs  ┊ GC (min … max): 0.00% … 0.00%
 Time  (median):     1.434 μs              ┊ GC (median):    0.00%
 Time  (mean ± σ):   1.438 μs ± 23.775 ns  ┊ GC (mean ± σ):  0.00% ± 0.00%

  ▂█▃                                                         
  ███▆▆▄▂▁▂▂▁▁▂▁▁▁▁▁▂▁▂▁▁▁▁▁▁▂▂▁▁▂▁▂▁▁▁▁▂▂▂▂▂▂▁▁▁▁▁▁▁▁▁▁▂▂▂▂ ▂
  1.43 μs        Histogram: frequency by time        1.55 μs <

 Memory estimate: 0 bytes, allocs estimate: 0.

julia> @benchmark axpy_batch!($y, eps(), $x)
BenchmarkTools.Trial: 10000 samples with 69 evaluations.
 Range (min … max):  853.623 ns …  2.361 μs  ┊ GC (min … max): 0.00% … 0.00%
 Time  (median):     885.507 ns              ┊ GC (median):    0.00%
 Time  (mean ± σ):   889.184 ns ± 25.306 ns  ┊ GC (mean ± σ):  0.00% ± 0.00%

              ▂▅▇██▆▆▄▁                                         
  ▁▁▁▁▁▁▂▂▃▄▆██████████▇▅▄▃▂▂▂▂▂▂▂▂▁▁▁▁▁▁▁▁▁▁▁▁▁▁▁▁▁▁▁▁▁▁▁▂▂▁▁ ▃
  854 ns          Histogram: frequency by time          968 ns <

 Memory estimate: 0 bytes, allocs estimate: 0.

julia> @benchmark axpy_atthreads!($y, eps(), $x)
BenchmarkTools.Trial: 10000 samples with 7 evaluations.
 Range (min … max):  4.437 μs … 388.400 μs  ┊ GC (min … max): 0.00% … 97.02%
 Time  (median):     5.077 μs               ┊ GC (median):    0.00%
 Time  (mean ± σ):   5.560 μs ±   9.340 μs  ┊ GC (mean ± σ):  4.03% ±  2.37%

         ▁▄▅██▇▆▃▁                                             
  ▁▁▁▂▃▅▆█████████▆▅▄▄▃▂▂▂▁▁▁▁▁▁▁▁▁▁▁▁▁▁▁▁▁▁▂▂▂▂▂▃▂▃▃▃▂▂▂▂▂▂▁ ▃
  4.44 μs         Histogram: frequency by time        7.44 μs <

 Memory estimate: 4.54 KiB, allocs estimate: 48.

julia> @benchmark axpy_atthreads_static!($y, eps(), $x)
BenchmarkTools.Trial: 10000 samples with 8 evaluations.
 Range (min … max):  3.078 μs … 357.969 μs  ┊ GC (min … max): 0.00% … 96.65%
 Time  (median):     3.618 μs               ┊ GC (median):    0.00%
 Time  (mean ± σ):   4.102 μs ±   9.118 μs  ┊ GC (mean ± σ):  5.75% ±  2.57%

         ▃▆█▆▅▂                                                
  ▂▂▂▃▄▆███████▇▅▄▃▃▃▂▂▂▂▂▂▂▂▂▂▂▂▂▁▂▂▂▂▂▂▂▂▃▂▃▃▃▃▃▃▃▃▃▃▃▃▂▂▂▂ ▃
  3.08 μs         Histogram: frequency by time        6.12 μs <

 Memory estimate: 4.56 KiB, allocs estimate: 48.

julia> @benchmark axpy!(eps(), $x, $y) # BLAS built-in axpy
BenchmarkTools.Trial: 10000 samples with 10 evaluations.
 Range (min … max):  1.438 μs …  9.397 μs  ┊ GC (min … max): 0.00% … 0.00%
 Time  (median):     1.441 μs              ┊ GC (median):    0.00%
 Time  (mean ± σ):   1.445 μs ± 83.630 ns  ┊ GC (mean ± σ):  0.00% ± 0.00%

   █                                                          
  ▄██▅▆▂▂▁▁▂▁▁▂▁▁▁▁▁▂▂▁▁▁▂▁▁▂▁▁▁▁▁▁▁▂▂▁▁▁▁▂▂▁▂▂▁▁▁▁▁▁▁▁▂▂▂▂▂ ▂
  1.44 μs        Histogram: frequency by time        1.55 μs <

 Memory estimate: 0 bytes, allocs estimate: 0.

julia> VERSION
v"1.9.3"
```

With only `10_000` elements, this simple AXPY computation can't afford the overhead of multithreading via `@threads` (for either scheduling scheme). In fact, the latter just slows the computation down. Similarly, the built-in BLAS `axpy!` doesn't provide any multithreading speedup (it likely falls back to a serial variant). Only with Polyester's `@batch`, which has minimal overhead, do we get a decent(!) speedup.

## Keyword options for `@batch`

### `per=cores` / `per=threads`

The `per` keyword argument can be used to limit the number of Julia threads to be used by a `@batch` block. Specifically, `per=core` will use only `max(num_cores, nthreads())` many of the Julia threads.

Note that `@batch` defaults to `per=cores`. This is because [LoopVectorization.jl](https://github.com/JuliaSIMD/LoopVectorization.jl) currently only uses up to 1 thread per physical core, and switching the number of
threads incurs some overhead.

### `minbatch`

The `minbatch` argument lets us choose a minimum number of iterations per thread. That is, `minbatch=n` means it'll use at most `number_loop_iterations ÷ n` threads.

For our benchmark example above with 10000 iterations, setting `minbatch=2500` will lead to `@batch` using only 4 (of 8) threads. This is still faster than the serial version but slower than plain `@batch`, which uses all 8 available threads.

```julia
function axpy_minbatch!(y, a, x)
    @batch minbatch=2500 for i in eachindex(y,x)
        @inbounds y[i] = a * x[i] + y[i]
    end
end

@benchmark axpy_minbatch!($y, $eps(), $x)
```

```julia
julia> @benchmark axpy_minbatch!($y, $eps(), $x)
BenchmarkTools.Trial: 10000 samples with 10 evaluations.
 Range (min … max):  1.072 μs …  5.085 μs  ┊ GC (min … max): 0.00% … 0.00%
 Time  (median):     1.114 μs              ┊ GC (median):    0.00%
 Time  (mean ± σ):   1.126 μs ± 72.510 ns  ┊ GC (mean ± σ):  0.00% ± 0.00%

       ▂▅██▅▃                                                 
  ▁▁▂▃▆███████▅▃▂▁▁▁▁▁▁▁▁▁▁▁▁▁▁▁▁▁▁▁▁▁▁▁▁▁▁▁▁▁▁▁▁▁▁▁▁▁▁▁▁▁▁▁ ▂
  1.07 μs        Histogram: frequency by time        1.36 μs <

 Memory estimate: 0 bytes, allocs estimate: 0.
```

### Local per-thread storage (`threadlocal`)

You also can define local storage for each thread, providing a vector containing each of the local storages at the end.

```julia
julia> let
           @batch threadlocal=rand(10:99) for i in 0:9
               println("index $i, thread $(Threads.threadid()), local storage $threadlocal")
               threadlocal += 1
           end
           println(threadlocal)
       end

index 8, thread 1, local storage 30
index 3, thread 3, local storage 49
index 9, thread 1, local storage 31
index 6, thread 4, local storage 33
index 0, thread 2, local storage 14
index 4, thread 3, local storage 50
index 7, thread 4, local storage 34
index 1, thread 2, local storage 15
index 5, thread 3, local storage 51
index 2, thread 2, local storage 16
Any[32, 17, 52, 35]
```

Optionally, a type can be specified for the thread-local storage:
```julia
julia> let
           @batch threadlocal=rand(10:99)::Float16 for i in 0:9
           end
           println(threadlocal)
       end

Float16[83.0, 90.0, 27.0, 65.0]
```

### `reduction`
The `reduction` keyword enables reduction of an already initialized `isbits` variable with certain supported associative operations (see [docs](https://JuliaSIMD.github.io/Polyester.jl/stable)), such that the transition from serialized code is as simple as adding the `@batch` macro. Contrary to `threadlocal` this does not incur any additional allocations

```julia
julia> function batch_reduction()
           y1 = 0
           y2 = 1
           @batch reduction=((+, y1), (*, y2)) for i in 1:9
               y1 += i
               y2 *= i
           end
           y1, y2
       end
julia> batch_reduction()
(45, 362880)
julia> @allocated batch_reduction()
0
```

## Disabling Polyester threads

When running many repetitions of a Polyester-multithreaded function (e.g. in an embarrassingly parallel problem that repeatedly executes a small already Polyester-multithreaded function), it can be beneficial to disable Polyester (the inner multithreaded loop) and multithread only at the outer level (e.g. with `Base.Threads`). This can be done with the `disable_polyester_threads` context manager. In the expandable section below you can see examples with benchmarks.

It is best to call `disable_polyester_threads` only once, before any `@thread` uses happen, to avoid overhead. E.g. best to do it as:
```julia
disable_polyester_threads() do
    @threads for i in 1:n
        f()
    end
end
```
instead of doing it in the following unnecessarily slow manner:
```julia
@threads for i in 1:n # DO NOT DO THIS
    disable_polyester_threads() do # IT HAS UNNECESSARY OVERHEAD
        f()
    end
end
```


<details>
<summary>Benchmarks of nested multi-threading with Polyester</summary>
    
```julia
# Big inner problem, repeated only a few times

y = rand(10000000,4);
x = rand(size(y)...);

@btime inner($x,$y,1) # 57.456 ms (0 allocations: 0 bytes)
@btime inner_polyester($x,$y,1) # 7.456 ms (0 allocations: 0 bytes)
@btime inner_thread($x,$y,1) # 7.286 ms (49 allocations: 4.56 KiB)

@btime sequential_sequential($x,$y) # 229.513 ms (0 allocations: 0 bytes)
@btime sequential_polyester($x,$y) # 29.921 ms (0 allocations: 0 bytes)
@btime sequential_thread($x,$y) # 29.343 ms (196 allocations: 18.25 KiB)

@btime threads_of_polyester($x,$y) # 29.961 ms (42 allocations: 4.34 KiB)
# the following is a purposefully suboptimal way to disable threads
@btime threads_of_polyester_inner_disable($x,$y) # 55.397 ms (51 allocations: 4.62 KiB)
# the following is a good way to disable threads (the disable call happening once in the outer scope)
@btime Polyester.disable_polyester_threads() do; threads_of_polyester($x,$y) end; # 55.396 ms (47 allocations: 4.50 KiB)
@btime threads_of_sequential($x,$y) # 55.404 ms (48 allocations: 4.53 KiB)
@btime threads_of_thread($x,$y) # 29.187 ms (220 allocations: 22.03 KiB)

# Small inner problem, repeated many times

y = rand(1000,1000);
x = rand(size(y)...);

@btime inner($x,$y,1) # 3.390 μs (0 allocations: 0 bytes)
@btime inner_polyester($x,$y,1) # 785.714 ns (0 allocations: 0 bytes)
@btime inner_thread($x,$y,1) # 4.043 μs (48 allocations: 4.54 KiB)

@btime sequential_sequential($x,$y) # 5.720 ms (0 allocations: 0 bytes)
@btime sequential_polyester($x,$y) # 1.143 ms (0 allocations: 0 bytes)
@btime sequential_thread($x,$y) # 4.796 ms (50307 allocations: 4.50 MiB)

@btime threads_of_polyester($x,$y) # 1.165 ms (42 allocations: 4.34 KiB)
# the following is a purposefully suboptimal way to disable threads
@btime threads_of_polyester_inner_disable($x,$y) # 779.713 μs (1042 allocations: 35.59 KiB)
# the following is a good way to disable threads (the disable call happening once in the outer scope)
@btime Polyester.disable_polyester_threads() do; threads_of_polyester($x,$y) end; # 743.813 μs (48 allocations: 4.53 KiB)
@btime threads_of_sequential($x,$y) # 694.463 μs (45 allocations: 4.44 KiB)
@btime threads_of_thread($x,$y) # 2.288 ms (42058 allocations: 4.25 MiB)

# The tested functions
# All of these would be better implemented by just using @tturbo,
# but these suboptimal implementations serve as good test case for
# Polyster-vs-Base thread scheduling.

function inner(x,y,j)
    for i ∈ axes(x,1)
        y[i,j] = sin(x[i,j])
    end
end

function inner_polyester(x,y,j)
    @batch for i ∈ axes(x,1)
        y[i,j] = sin(x[i,j])
    end
end

function inner_thread(x,y,j)
    @threads for i ∈ axes(x,1)
        y[i,j] = sin(x[i,j])
    end
end

function sequential_sequential(x,y)
    for j ∈ axes(x,2)
        inner(x,y,j)
    end
end

function sequential_polyester(x,y)
    for j ∈ axes(x,2)
        inner_polyester(x,y,j)
    end
end

function sequential_thread(x,y)
    for j ∈ axes(x,2)
        inner_thread(x,y,j)
    end
end

function threads_of_polyester(x,y)
    @threads for j ∈ axes(x,2)
        inner_polyester(x,y,j)
    end
end

function threads_of_polyester_inner_disable(x,y)
    # XXX This is a bad way to disable Polyester threads as
    # it causes unnecessary overhead for each @threads thread.
    # See the benchmarks above for a better way.
    @threads for j ∈ axes(x,2)
        Polyester.disable_polyester_threads() do
            inner_polyester(x,y,j)
        end
    end
end

function threads_of_thread(x,y)
    @threads for j ∈ axes(x,2)
        inner_thread(x,y,j)
    end
end

function threads_of_thread(x,y)
    @threads for j ∈ axes(x,2)
        inner_thread(x,y,j)
    end
end

function threads_of_sequential(x,y)
    @threads for j ∈ axes(x,2)
        inner(x,y,j)
    end
end
```
Benchmarks executed on:
```
Julia Version 1.9.3
Commit bed2cd540a1 (2023-08-24 14:43 UTC)
Build Info:
  Official https://julialang.org/ release
Platform Info:
  OS: Linux (x86_64-linux-gnu)
  CPU: 128 × AMD EPYC 7V13 64-Core Processor
  WORD_SIZE: 64
  LIBM: libopenlibm
  LLVM: libLLVM-14.0.6 (ORCJIT, znver3)
  Threads: 8 on 128 virtual cores
Environment:
  JULIA_NUM_THREADS = 8
```
</details>

module Polyester
if isdefined(Base, :Experimental) && isdefined(Base.Experimental, Symbol("@max_methods"))
  @eval Base.Experimental.@max_methods 1
end

using ThreadingUtilities
import StaticArrayInterface
const ArrayInterface = StaticArrayInterface
using Base.Cartesian: @nexprs
using StaticArrayInterface: static_length, static_step, static_first, static_size
using StrideArraysCore: object_and_preserve
using ManualMemory: Reference
using Static
using PolyesterWeave:
  PolyesterWeave,
  request_threads,
  free_threads!,
  mask,
  UnsignedIteratorEarlyStop,
  assume,
  disable_polyester_threads
using CPUSummary: num_cores

export batch, @batch, disable_polyester_threads

const SUPPORTED_REDUCE_OPS = (:+, :*, :min, :max, :&, :|)
initializer(::typeof(+), ::T) where {T} = zero(T)
initializer(::typeof(+), ::Bool) = zero(Int)
initializer(::typeof(*), ::T) where {T} = one(T)
initializer(::typeof(min), ::T) where {T} = typemax(T)
initializer(::typeof(max), ::T) where {T} = typemin(T)
initializer(::typeof(&), ::Bool) = true
initializer(::typeof(|), ::Bool) = false

include("batch.jl")
include("closure.jl")


# see https://github.com/JuliaSIMD/Polyester.jl/issues/30
"""
    Polyester.reset_threads!()

Resets the threads used by [Polyester.jl](https://github.com/JuliaSIMD/Polyester.jl).
"""
function reset_threads!()
  PolyesterWeave.reset_workers!()
  foreach(ThreadingUtilities.reinit_task, eachindex(ThreadingUtilities.TASKS))
  return nothing
end
end

using Polyester
using Documenter

DocMeta.setdocmeta!(Polyester, :DocTestSetup, :(using Polyester); recursive = true)

makedocs(;
  modules = [Polyester],
  authors = "Chris Elrod <elrodc@gmail.com> and contributors",
  repo = "https://github.com/JuliaSIMD/Polyester.jl/blob/{commit}{path}#{line}",
  sitename = "Polyester.jl",
  format = Documenter.HTML(;
    prettyurls = get(ENV, "CI", "false") == "true",
    canonical = "https://JuliaSIMD.github.io/Polyester.jl",
    assets = String[],
  ),
  pages = ["Home" => "index.md"],
)

deploydocs(; repo = "github.com/JuliaSIMD/Polyester.jl")

function getgensym!(defined::Dict{Symbol,Symbol}, s::Symbol)
  snew = get!(defined, s) do
    gensym(s)
  end
  snew ≢ s && (defined[snew] = snew)
  return snew
end

extractargs!(arguments::Vector{Symbol}, defined::Dict{Symbol,Symbol}, sym, mod) = nothing
# function extractargs!(arguments::Vector{Symbol}, defined::Dict{Symbol,Symbol}, sym::Symbol, mod)
#   if ((sym ∉ keys(defined)) && sym ∉ (:nothing, :(+), :(*), :(-), :(/), :(÷), :(<<), :(>>), :(>>>), :zero, :one)) && !Base.isconst(mod, sym)
#     @show getgensym!(defined, sym)
#     @assert false
#     push!(arguments, getgensym!(defined, sym))
#   end
#   nothing
# end

function _symbols(args)
  s = Vector{Symbol}(undef, length(args))
  for i in eachindex(args, s)
    s[i] = args[i]
  end
  return s
end

function define_tup!(arguments::Vector{Symbol}, defined::Dict{Symbol,Symbol}, ex::Expr, mod)
  for (i, a) ∈ enumerate(ex.args)
    if a isa Symbol
      ex.args[i] = getgensym!(defined, a)
    elseif Meta.isexpr(a, :tuple)
      define_tup!(_symbols(a.args), defined, a, mod)
    elseif Meta.isexpr(a, :ref)
      extractargs!(arguments, defined, a, mod)
    elseif Meta.isexpr(a, :parameters)
      define_tup!(_symbols(a.args), defined, a, mod)
    else
      throw("Don't know how to handle:\n $a")
    end
  end
end
function define1!(
  arguments::Vector{Symbol},
  defined::Dict{Symbol,Symbol},
  x::Vector{Any},
  mod,
)
  s = x[1]
  if s isa Symbol
    x[1] = getgensym!(defined, s)
  else
    define_tup!(arguments, defined, s::Expr, mod)
  end
end
function define_induction_variables!(
  arguments::Vector{Symbol},
  defined::Dict{Symbol,Symbol},
  ex::Expr,
  mod,
) # add `i` in `for i ∈ looprange` to `defined`
  ex.head === :for || return
  loops = ex.args[1]
  if loops.head === :block
    for loop ∈ loops.args
      define1!(arguments, defined, loop.args, mod)
    end
  else
    define1!(arguments, defined, loops.args, mod)
  end
end

function extractargs_equal!(
  arguments::Vector{Symbol},
  defined::Dict{Symbol,Symbol},
  args::Vector{Any},
  mod,
)
  arg1 = first(args)
  if arg1 isa Symbol
    args[1] = getgensym!(defined, arg1)
  elseif Meta.isexpr(arg1, :tuple)
    define_tup!(arguments, defined, arg1, mod)
  end
  nothing
end

function must_add_sym(defined::Dict{Symbol,Symbol}, arg::Symbol, mod)
  (
    (arg ∉ keys(defined)) &&
    arg ∉ (:nothing, :(+), :(*), :(-), :(/), :(÷), :(<<), :(>>), :(>>>), :zero, :one)
  ) && !Base.isconst(mod, arg)
end
function get_sym!(defined::Dict{Symbol,Symbol}, arguments::Vector{Symbol}, arg::Symbol, mod)
  if must_add_sym(defined, arg, mod)
    # @show getgensym!(defined, sym)
    # @assert false
    push!(arguments, arg)
    getgensym!(defined, arg)
  else
    get(defined, arg, arg)
  end
end
function extractargs!(
  arguments::Vector{Symbol},
  defined::Dict{Symbol,Symbol},
  expr::Expr,
  mod,
)
  define_induction_variables!(arguments, defined, expr, mod)
  head = expr.head
  args = expr.args

  startind = 1
  if head === :call
    arg1 = args[1]
    if arg1 isa Symbol && (first(string(arg1)) != '.')
      startind = isdefined(mod, arg1) ? 2 : 1
    else
      startind = 2
    end
  elseif head === :(=)
    extractargs_equal!(arguments, defined, args, mod)
  elseif head ∈ (:inbounds, :loopinfo)#, :(->))
    return
  elseif head === :(.)
    arg1 = args[1]
    if arg1 isa Symbol
      args[1] = get_sym!(defined, arguments, arg1, mod)
    else
      extractargs!(arguments, defined, arg1, mod)
    end
  elseif head === :(->)
    td = copy(defined)
    define1!(arguments::Vector{Symbol}, td, args, mod)
    extractargs!(arguments, td, args[1], mod)
    extractargs!(arguments, td, args[2], mod)
    return
  elseif head === :generator
    extractargs_equal!(arguments, defined, args[2].args, mod)
  elseif (head === :local) || (head === :global)
    for (i, arg) in enumerate(args)
      if Meta.isexpr(arg, :(=))
        extractargs_equal!(arguments, defined, arg.args, mod)
        args = arg.args
        startind = 2
      else
        args[i] = getgensym!(defined, arg)
        return
      end
    end
  elseif head === :kw
    if args[2] isa Symbol
      args[2] = get_sym!(defined, arguments, args[2], mod)
    else
      extractargs!(arguments, defined, args[2], mod)
    end
    return
  elseif head === :parameters
    for (i, arg) in enumerate(args)
      if arg isa Symbol
        sym = get_sym!(defined, arguments, arg, mod)
        args[i] = Expr(:kw, arg, sym)
      else
        extractargs!(arguments, defined, arg, mod)
      end
    end
    return
  end
  for i ∈ startind:length(args)
    argᵢ = args[i]
    (head === :ref && ((argᵢ === :end) || (argᵢ === :begin))) && continue
    if argᵢ isa Symbol
      args[i] = get_sym!(defined, arguments, argᵢ, mod)
    elseif argᵢ isa Expr
      extractargs!(arguments, defined, argᵢ, mod)
    else
      extractargs!(arguments, defined, argᵢ, mod)
    end
  end
  return
end

function symbolsubs(e::Expr, old::Symbol, new::Symbol)
  ex = Expr(e.head)
  resize!(ex.args, length(e.args))
  for i in eachindex(e.args, ex.args)
    ex.args[i] = symbolsubs(e.args[i], old, new)
  end
  return ex
end
function symbolsubs(e::Symbol, old::Symbol, new::Symbol)
  e == old ? new : e
end
symbolsubs(e, old::Symbol, new::Symbol) = e

struct NoLoop end
Base.iterate(::NoLoop) = (NoLoop(), NoLoop())
Base.iterate(::NoLoop, ::NoLoop) = nothing
@inline splitloop(x) = NoLoop(), x, CombineIndices()
struct CombineIndices end
@inline splitloop(x::AbstractRange) = NoLoop(), x, CombineIndices()
@inline function splitloop(x::CartesianIndices)
  axes = x.indices
  CartesianIndices(Base.front(axes)), last(axes), CombineIndices()
end
@inline function splitloop(x::AbstractArray)
  inds = eachindex(x)
  inner, outer = splitloop(inds)
  inner, outer, x
end
struct TupleIndices end
@inline function splitloop(x::Base.Iterators.ProductIterator{Tuple{T1,T2}}) where {T1,T2}
  iters = x.iterators
  iters[1], iters[2], TupleIndices()
end
@inline function splitloop(
  x::Base.Iterators.ProductIterator{<:Tuple{Vararg{Any,N}}},
) where {N}
  iters = x.iterators
  Base.front(iters), iters[N], TupleIndices()
end
combine(::CombineIndices, ::NoLoop, x) = x
combine(::CombineIndices, I::CartesianIndex, j) = CartesianIndex((I.I..., j))
combine(::TupleIndices, i::Tuple, j) = (i..., j)
combine(::TupleIndices, i::Number, j) = (i, j)

Base.@propagate_inbounds combine(x::AbstractArray, I, j) =
  x[combine(CombineIndices(), I, j)]
Base.@propagate_inbounds combine(x::AbstractArray, ::NoLoop, j) = x[j]

struct WrapType{T} end
wrap_type(@nospecialize(x)) = x
wrap_type(::Type{T}) where {T} = WrapType{T}()

unwrap_type(@nospecialize(x)) = x
unwrap_type(::WrapType{T}) where {T} = T

function makestatic!(expr)
  expr isa Expr || return expr
  for i in eachindex(expr.args)
    ex = expr.args[i]
    if ex isa Int
      expr.args[i] = static(ex)
    elseif ex isa Symbol
      j = findfirst(==(ex), (:axes, :size, :length))
      if j !== nothing
        expr.args[i] =
          GlobalRef(ArrayInterface, (:static_axes, :static_size, :static_length)[j])
      end
    elseif ex isa Expr
      makestatic!(ex)
    end
  end
  expr
end
function enclose(exorig::Expr, minbatchsize, per, threadlocal, reduction, stride, mod)
  Meta.isexpr(exorig, :for, 2) ||
    throw(ArgumentError("Expression invalid; should be a for loop."))
  ex = copy(exorig)
  loop_sym = Symbol("##LOOP##")
  loopstart = Symbol("##LOOPSTART##")
  loop_step = Symbol("##LOOP_STEP##")
  loop_stop = Symbol("##LOOP_STOP##")
  iter_leng = Symbol("##ITER_LENG##")
  loop_offs = Symbol("##LOOPOFFSET##")
  innerloop = Symbol("##inner##loop##")
  rcombiner = Symbol("##split##recombined##")
  reduction_op, reduction_var = reduction
  threadlocal_var = Symbol("threadlocal")
  #FIXME: don't do this?
  per = stride ? :thread : per
  # arguments = Symbol[]#loop_offs, loop_step]
  arguments = Symbol[innerloop, rcombiner]#loop_offs, loop_step]
  defined = Dict{Symbol,Symbol}(loop_offs => loop_offs, loop_step => loop_step)
  threadlocal_var_gen = getgensym!(defined, threadlocal_var)
  reduction_var_gen = Expr(:tuple)
  if reduction_var !== Tuple{}()
    for i ∈ eachindex(reduction_var)
      push!(reduction_var_gen.args, getgensym!(defined, reduction_var[i]))
    end
  end
  define_induction_variables!(arguments, defined, ex, mod)
  firstloop = ex.args[1]
  if firstloop.head === :block
    secondaryloopsargs = firstloop.args[2:end]
    firstloop = firstloop.args[1]
  else
    secondaryloopsargs = Any[]
  end
  loop = firstloop.args[2]
  # @show ex loop
  body = ex.args[2]
  if length(secondaryloopsargs) == 1
    body = Expr(:for, only(secondaryloopsargs), body)
  elseif length(secondaryloopsargs) > 1
    sl = Expr(:block)
    append!(sl.args, secondaryloopsargs)
    body = Expr(:for, sl, body)
  end
  fla1 = firstloop.args[1]
  excomb = if fla1 isa Symbol
    fla1 = getgensym!(defined, fla1)
    quote
      # for $(firstloop.args[1]) in
      var"##outer##"::Int = Int($loopstart)::Int
      while var"##outer##" <= $loop_stop
        for var"##inner##" in $innerloop
          $fla1 = $combine($rcombiner, var"##inner##", var"##outer##")
          $body
        end
        var"##outer##" += var"##STEP##"
      end
    end
  else
    @assert fla1 isa Expr
    for i in eachindex(fla1.args)
      fla1.args[i] = getgensym!(defined, fla1.args[i])
    end
    quote
      # for $(firstloop.args[1]) in
      var"##outer##"::Int = Int($loopstart)::Int
      while var"##outer##" <= $loop_stop
        for var"##inner##" in $innerloop
          $fla1 = $combine($rcombiner, var"##inner##", var"##outer##")
          $body
        end
        var"##outer##" += var"##STEP##"
      end
    end
  end
  if ex.args[1].head === :block
    for i ∈ 2:length(ex.args[1].args)
      extractargs!(arguments, defined, ex.args[1].args[i], mod)
    end
  end
  for i ∈ 2:length(ex.args)
    extractargs!(arguments, defined, ex.args[i], mod)
  end
  # @show ex.args[1] firstloop body
  # if length(ex.args[
  # ex = quote
  #   # for $(firstloop.args[1]) in
  #   for var"##outer##" in $firstlooprange, var"##inner##" in $innerloop
  #     $(firstloop.args[1]) = $combine($rcombiner, var"##inner##", var"##outer##")
  #     $body
  #   end
  # end
  # typexpr_incomplete is missing `funcs`
  # outerloop = Symbol("##outer##")
  num_thread_expr::Union{Symbol,Expr} = if per === :core
    Expr(:call, min, Symbol("##NUM#THREADS##"), Expr(:call, num_cores))
  else
    Symbol("##NUM#THREADS##")
  end

  iter_len_def = quote
    $(esc(innerloop)), $loop_sym, $(esc(rcombiner)) = $splitloop($(esc(makestatic!(loop))))
    $iter_leng = $static_length($loop_sym)
  end

  q = quote
    var"##NUM#THREADS#TO#USE##" = $num_thread_expr
    $(stride ? nothing : iter_len_def)
    $loop_step = $static_step($loop_sym)
    $loop_offs = $static_first($loop_sym)
  end
  threadtup = Expr(:tuple, iter_leng)
  if minbatchsize isa Integer && minbatchsize ≤ 1
    push!(threadtup.args, :(min($iter_leng, var"##NUM#THREADS#TO#USE##")))
  else
    il = :(div(
      $iter_leng,
      $(minbatchsize isa Int ? StaticInt(minbatchsize) : esc(minbatchsize)),
    ))
    push!(threadtup.args, :(min($il, $num_thread_expr)))
  end
  closure = Symbol("##closure##")
  donothing = Expr(:block)
  return_quote = Expr(:return)
  # threadlocal stuff
  threadlocal_var_single = gensym(threadlocal_var)
  threadlocal_val, threadlocal_type = threadlocal
  q_single =
    threadlocal_val === Symbol("") ? exorig :
    symbolsubs(exorig, threadlocal_var, threadlocal_var_single)
  # threadlocal_type = getfield(mod, threadlocal_type)
  threadlocal_accum = Symbol("##THREADLOCAL##ACCUM##")
  threadlocal_init_single =
    threadlocal_val === Symbol("") ? donothing :
    :($threadlocal_var_single = $threadlocal_val)
  threadlocal_return_single =
    threadlocal_val === Symbol("") ? donothing : :($threadlocal_var_single)
  threadlocal_vect_single =
    threadlocal_val === Symbol("") ? donothing :
    :($(esc(threadlocal_var)) = [single_thread_result])
  threadlocal_init =
    threadlocal_val === Symbol("") ? donothing :
    quote
      $(esc(threadlocal_accum)) =
        Vector{$threadlocal_type}(undef, max(1, $(threadtup.args[2])))
    end
  threadlocal_vect =
    threadlocal_val === Symbol("") ? donothing :
    :($(esc(threadlocal_var)) = multi_thread_result)
  threadlocal_get =
    threadlocal_val === Symbol("") ? donothing :
    :($threadlocal_var_gen::$threadlocal_type = $threadlocal_val)
  threadlocal_set =
    threadlocal_val === Symbol("") ? donothing :
    :($threadlocal_accum[var"##THREAD##"] = $threadlocal_var_gen)
  threadlocal_return = threadlocal_val === Symbol("") ? donothing : :($threadlocal_accum)
  threadlocal_val !== Symbol("") && push!(q.args, threadlocal_init)
  # reduction stuff
  reduction_ops = Expr(:tuple)
  reduction_vars = Expr(:tuple)
  reduction_inits = Expr(:tuple)
  reduction_set = Expr(:block)
  for i in eachindex(reduction_var)
    op = getfield(Polyester, reduction_op[i])
    var = esc(reduction_var[i])
    init = :(initializer($op, $var))
    push!(reduction_ops.args, op)
    push!(reduction_vars.args, var)
    push!(reduction_inits.args, init)
    push!(reduction_set.args, :($var = $op($var, reduction_final[$i])))
  end
  reduction_init =
    reduction_var === Tuple{}() ? donothing :
    :($reduction_var_gen = var"##REDUCTION##INIT##")
  if reduction_var !== Tuple{}()
    push!(return_quote.args, reduction_var_gen)
  else
    push!(return_quote.args, nothing)
  end

  args = Expr(:tuple, Symbol("##LOOPOFFSET##"), Symbol("##LOOP_STEP##"))
  closure_args = Expr(:tuple, args, :(var"##SUBSTART##"::Int), :(var"##SUBSTOP##"::Int))
  if threadlocal_val !== Symbol("") || stride
    push!(closure_args.args, :(var"##THREAD##"::Int))
  end
  reduction_var !== Tuple{}() && push!(closure_args.args, Symbol("##REDUCTION##INIT##"))
  if stride
    # we are to do length(var"##SUBSTART##":var"##SUBSTOP##") iterations
    loop_start_expr =
      :(var"##THREAD##" * var"##LOOP_STEP##" + var"##LOOPOFFSET##" - var"##LOOP_STEP##")
    loop_stop_expr = :($loopstart + (var"##SUBSTOP##" - var"##SUBSTART##") * var"##STEP##")
  else
    loop_start_expr =
      :(var"##SUBSTART##" * var"##LOOP_STEP##" + var"##LOOPOFFSET##" - var"##LOOP_STEP##")
    loop_stop_expr =
      :(var"##SUBSTOP##" * var"##LOOP_STEP##" + var"##LOOPOFFSET##" - var"##LOOP_STEP##")
  end
  unwrap_args = Expr(:block)
  closureq = quote
    $closure = let
      @inline $closure_args -> begin
        $unwrap_args
        local var"##STEP##" = $(
          stride ?
          :($loop_step * min(Threads.nthreads()::Int, Sys.CPU_THREADS::Int)) :
          loop_step
        )
        local $loopstart = $loop_start_expr
        local $loop_stop = $loop_stop_expr
        # $(stride ? :(@show $loopstart, $loop_stop) : nothing)
        $threadlocal_get
        $reduction_init
        @inbounds begin
          $excomb
        end
        $threadlocal_set
        $return_quote
      end
    end
  end
  push!(q.args, esc(closureq))
  batchcall = if threadlocal_val !== Symbol("") || stride
    Expr(
      :call,
      batch,
      esc(closure),
      Val(true),
      reduction_ops,
      reduction_inits,
      threadtup,
      Symbol("##LOOPOFFSET##"),
      Symbol("##LOOP_STEP##"),
    )
  else
    Expr(
      :call,
      batch,
      esc(closure),
      Val(false),
      reduction_ops,
      reduction_inits,
      threadtup,
      Symbol("##LOOPOFFSET##"),
      Symbol("##LOOP_STEP##"),
    )
  end
  for a ∈ arguments
    push!(args.args, get(defined, a, a))
    push!(batchcall.args, :($wrap_type($(esc(a)))))
  end
  if threadlocal_val !== Symbol("")
    push!(args.args, threadlocal_accum)
    push!(batchcall.args, esc(threadlocal_accum))
  end
  for a in args.args
    push!(unwrap_args.args, :($a = $unwrap_type($a)))
  end
  push!(q.args, batchcall)
  quote
    var"##NUM#THREADS##" = $(Threads.nthreads)()
    $(stride ? iter_len_def : nothing)
    if (
      $(
        stride ? :((var"##NUM#THREADS##" == 1) || (var"##NUM#THREADS##" > $iter_leng)) :
        :(var"##NUM#THREADS##" == 1)
      )
    )
      single_thread_result = begin
        $(esc(threadlocal_init_single)) # Initialize threadlocal storage
        $(esc(q_single))
        $(esc(threadlocal_return_single))
      end
      $threadlocal_vect_single
    else
      multi_thread_result = let
        reduction_final = $q
        $reduction_set
        $(esc(threadlocal_return))
      end
      $threadlocal_vect
    end
    nothing
  end
end

"""
    @batch for i in Iter; ...; end

Evaluate the loop on multiple threads. The execution of the loop waits for the evaluation
of all iterations.

    @batch minbatch=N for i in Iter; ...; end

Evaluate at least N iterations per thread. Will use at most `length(Iter) ÷ N` threads.

    @batch threadlocal=init() for i in Iter; ...; end

Create a thread-local storage used in the loop.

The `init` function will be called at the start at each thread. `threadlocal` will
refer to storage local for the thread. At the end of the loop, a `threadlocal`
vector containing all the thread-local values will be available. A type can be specified
with `threadlocal=init()::Type`.

    @batch reduction=((op1, var1), (op2, var2), ...) for i in Iter; ...; end

Perform OpenMP-esque reduction on the `isbits` variables `var1`, `var2`, `...` using the
operations `op1`, `op2`, `...` . The variables have to be initialized before the loop and
cannot be a fieldname like `x.y` or `x[i]`.
Supported operations are `+`, `*`, `min`, `max`, `&`, and `|`. The type does not have
to be provided, since it is already inferred from the initialized variables---**caution has
to be taken to ensure that the type remains consistent throughout the loop**.
While `threadlocal` can do the same thing, `reduction` does not incur additional allocations
and is generally more efficient for its purpose. It is up to the user to ensure that there
are no data dependencies between iterations, which could lead to incorrect results.

    @batch per=core for i in Iter; ...; end
    @batch per=thread for i in Iter; ...; end

Use at most 1 thread per physical core, or 1 thread per CPU thread, respectively.
One thread per core will mean less threads competing for the cache, while (for example) if
there are two hardware threads per physical core, then using each thread means that there
are two independent instruction streams feeding the CPU's execution units. When one of
these streams isn't enough to make the most of out of order execution, this could increase
total throughput.

Which performs better will depend on the workload, so if you're not sure it may be worth
benchmarking both.

LoopVectorization.jl currently only uses up to 1 thread per physical core. Because there
is some overhead to switching the number of threads used, `per=core` is `@batch`'s default,
so that `Polyester.@batch` and `LoopVectorization.@tturbo` work well together by default.

Threads are not pinned to a given CPU core and the total number of available threads is
still governed by `--threads` or `JULIA_NUM_THREADS`.

You can pass both `per=(core/thread)` and `minbatch=N` options at the same time, e.g.

    @batch per=thread minbatch=2000 for i in Iter; ...; end
    @batch minbatch=5000 per=core   for i in Iter; ...; end

    @batch stride=true for i in Iter; ...; end

This may be better for load balancing if iterations close to each other take a similar
amount of time, but iterations far apart take different lengths of time. Setting this also
forces `per=thread`. The default is `stride=false`.
"""
macro batch(ex)
  enclose(
    macroexpand(__module__, ex),
    1,
    :unspecified,
    (Symbol(""), :Any), # threadlocal: var, type
    (Tuple{}(), Tuple{}()), # reduction: ops, vars
    false,
    __module__,
  )
end
function interpret_kwarg(
  arg,
  minbatch = 1,
  per = :unspecified,
  threadlocal = (Symbol(""), :Any), # var, type
  reduction = (Tuple{}(), Tuple{}()), # ops, vars
  stride = false,
)
  a = arg.args[1]
  v = arg.args[2]
  if a === :minbatch
    minbatch = v
  elseif a === :per
    per = v::Symbol
    @assert (per === :core) | (per === :thread)
  elseif a === :reduction
    @assert Meta.isexpr(v, :tuple) && v.head == :tuple
    if Meta.isexpr(v.args[1], :tuple, 2)
      for red in v.args
        @assert Meta.isexpr(red, :tuple, 2) && red.head == :tuple
      end
      reducops = ntuple(length(v.args)) do i
        v.args[i].args[1]
      end
      @assert SUPPORTED_REDUCE_OPS ⊇ reducops "Unsupported reduction operation."
      reducvars = ntuple(length(v.args)) do i
        v.args[i].args[2]
      end
      @assert allunique(reducvars)
      reduction = (reducops, reducvars)
    else
      reduction = ((v.args[1],), (v.args[2],))
    end
  elseif a === :threadlocal
    if Meta.isexpr(v, :(::), 2) && v.head == :(::)
      threadlocal = (v.args[1], v.args[2])
    else
      threadlocal = (v, :Any)
    end
  elseif a === :stride
    stride = v::Bool
  else
    throw(ArgumentError("kwarg $(a) not recognized."))
  end
  minbatch, per, threadlocal, reduction, stride
end
macro batch(arg1, ex)
  minbatch, per, threadlocal, reduction, stride = interpret_kwarg(arg1)
  per = per === :unspecified ? (stride ? :thread : :core) : per
  enclose(
    macroexpand(__module__, ex),
    minbatch,
    per,
    threadlocal,
    reduction,
    stride,
    __module__,
  )
end
macro batch(arg1, arg2, ex)
  minbatch, per, threadlocal, reduction, stride = interpret_kwarg(arg1)
  minbatch, per, threadlocal, reduction, stride =
    interpret_kwarg(arg2, minbatch, per, threadlocal, reduction, stride)
  per = per === :unspecified ? (stride ? :thread : :core) : per
  enclose(
    macroexpand(__module__, ex),
    minbatch,
    per,
    threadlocal,
    reduction,
    stride,
    __module__,
  )
end
macro batch(arg1, arg2, arg3, ex)
  minbatch, per, threadlocal, reduction, stride = interpret_kwarg(arg1)
  minbatch, per, threadlocal, reduction, stride =
    interpret_kwarg(arg2, minbatch, per, threadlocal, reduction, stride)
  minbatch, per, threadlocal, reduction, stride =
    interpret_kwarg(arg3, minbatch, per, threadlocal, reduction, stride)
  per = per === :unspecified ? (stride ? :thread : :core) : per
  enclose(
    macroexpand(__module__, ex),
    minbatch,
    per,
    threadlocal,
    reduction,
    stride,
    __module__,
  )
end
macro batch(arg1, arg2, arg3, arg4, ex)
  minbatch, per, threadlocal, reduction, stride = interpret_kwarg(arg1)
  minbatch, per, threadlocal, reduction, stride =
    interpret_kwarg(arg2, minbatch, per, threadlocal, reduction, stride)
  minbatch, per, threadlocal, reduction, stride =
    interpret_kwarg(arg3, minbatch, per, threadlocal, reduction, stride)
  minbatch, per, threadlocal, reduction, stride =
    interpret_kwarg(arg4, minbatch, per, threadlocal, reduction, stride)
  per = per === :unspecified ? (stride ? :thread : :core) : per
  enclose(
    macroexpand(__module__, ex),
    minbatch,
    per,
    threadlocal,
    reduction,
    stride,
    __module__,
  )
end
macro batch(arg1, arg2, arg3, arg4, arg5, ex)
  minbatch, per, threadlocal, reduction, stride = interpret_kwarg(arg1)
  minbatch, per, threadlocal, reduction, stride =
    interpret_kwarg(arg2, minbatch, per, threadlocal, reduction, stride)
  minbatch, per, threadlocal, reduction, stride =
    interpret_kwarg(arg3, minbatch, per, threadlocal, reduction, stride)
  minbatch, per, threadlocal, reduction, stride =
    interpret_kwarg(arg4, minbatch, per, threadlocal, reduction, stride)
  minbatch, per, threadlocal, reduction, stride =
    interpret_kwarg(arg5, minbatch, per, threadlocal, reduction, stride)
  per = per === :unspecified ? (stride ? :thread : :core) : per
  enclose(
    macroexpand(__module__, ex),
    minbatch,
    per,
    threadlocal,
    reduction,
    stride,
    __module__,
  )
end

println(
  "Starting tests with $(Threads.nthreads()) threads out of `Sys.CPU_THREADS = $(Sys.CPU_THREADS)`...",
)
using Polyester, Aqua, ForwardDiff
using PolyesterWeave: dynamic_thread_count # min(Sys.CPU_THREADS, Threads.nthreads())
using Base.Threads: @threads
using Test

function bsin!(y, x, r = eachindex(y, x))
  @batch for i ∈ r
    y[i] = sin(x[i])
  end
  return y
end
function bsin_stride!(y, x, r = eachindex(y, x))
  @batch stride = true for i ∈ r
    y[i] = sin(x[i])
  end
  return y
end
function bcos!(y, x)
  @batch per = core for i ∈ eachindex(y, x)
    local cxᵢ
    cxᵢ = cos.(x[i])
    y[i] = cxᵢ
  end
  return y
end
myindices(x) = 1:length(x) # test hygiene, issue #11
function sin_batch_sum(v)
  s = zeros(8, Threads.nthreads())
  @batch minbatch = 10 for i in myindices(v)
    s[1, Threads.threadid()] += sin(v[i])
  end
  if cld(length(v), 10) < Threads.nthreads()
    @test s[1, end] == 0.0
  end
  return sum(view(s, 1, :))
end
function rowsum_batch!(x, A)
  @batch for n ∈ axes(A, 2)
    local s = 0.0
    @simd for m ∈ axes(A, 1)
      s += A[m, n]
    end
    x[n] = s
  end
end
function bar!(dest, src)
  @batch for i in eachindex(dest)
    dest[i] = src.a.b[i]
  end
  dest
end

function rangemap!(f::F, allargs, start, stop) where {F}
  dest = first(allargs)
  args = Base.tail(allargs)
  @inbounds @simd for i ∈ start:stop
    dest[i] = f(Base.unsafe_getindex.(args, i)...)
  end
  nothing
end

function tmap!(f::F, args::Vararg{AbstractArray,K}) where {K,F}
  dest = first(args)
  N = length(dest)
  mapfun! = (allargs, start, stop) -> rangemap!(f, allargs, start, stop)
  batch(mapfun!, (N, Int(Threads.nthreads())), args...)
  dest
end
function issue15!(dest, src)
  @batch for i in eachindex(src)
    dest.src[i] = src[i]
  end
  dest
end
function issue16!(dest)
  @batch for i = 2:1
    dest[i] = i
  end
  true
end
function issue17!(dest)
  @assert size(dest, 1) == 5
  @batch for j in axes(dest, 2)
    x = ntuple(i -> i * j, Val(5)) # works if this line is commented out
    for i in axes(dest, 1)
      dest[i, j] = i * j
    end
  end
end
function issue18!(dest)
  @assert length(dest) == 3
  @assert dest[1] == 1
  @batch for i = 2:3
    dest[i] = i
  end
  @test dest ≈ 1:3
end

function issue25!(dest, x, y)
  @batch for (i, j) ∈ Iterators.product(eachindex(x), eachindex(y))
    dest[i, j] = x[i, begin] * y[j, end]
  end
  dest
end
function issue25_but_with_strides!(dest, x, y)
  @batch stride = true for (i, j) ∈ Iterators.product(eachindex(x), eachindex(y))
    dest[i, j] = x[i, begin] * y[j, end]
  end
  dest
end

function issue108!(y::Vector{T1}, x::Vector{T2}) where {T1,T2}
  @batch for i in eachindex(y)
    y[i] = sum(x[j] for j = 2i-oneunit(i):2i)
  end
end

function issue108_comment!(data::Vector{T}, functions) where {T}
  @batch for i in eachindex(data)
    for f in functions
      data[i] += f(data[i])
    end
  end
end

function issue116!(y::Vector{T}, x::Vector{T}) where {T}
  @batch for i = 1:length(x)
    y[i] = exp(x[i] + one(T))
  end
end


@testset "Range Map" begin

  x = rand(1024)
  y = rand(length(x))
  z = similar(x)
  foo(x, y) = exp(-0.5abs2(x - y))
  println("Running `tmap!` test...")
  @test tmap!(foo, z, x, y) ≈ foo.(x, y)

  function slow_task!((x, digits, n), j, k)
    start = 1 + (n * (j - 1)) ÷ Threads.nthreads()
    stop = (n * k) ÷ Threads.nthreads()
    target = 0.0
    for i ∈ start:stop
      target += occursin(digits, string(i)) ? 0.0 : 1.0 / i
    end
    x[1, j] = target
  end

  function slow_cheap(n, digits)
    x = zeros(8, Int(Threads.nthreads()))
    batch(slow_task!, (Threads.nthreads(), Threads.nthreads()), x, digits, n)
    sum(@view(x[1, 1:end]))
  end

  function slow_single_thread(n, digits)
    target = 0.0
    for i ∈ 1:n
      target += occursin(digits, string(i)) ? 0.0 : 1.0 / i
    end
    return target
  end

  @test slow_cheap(1000, "9") ≈ slow_single_thread(1000, "9")

  x = randn(100_000)
  y = similar(x)
  z = similar(y)
  @test bsin!(y, x) == (z .= sin.(x))
  fill!(y, NaN)
  @test bsin_stride!(y, x) == z
  @test bcos!(y, x) == (z .= cos.(x))
  @views z[1:3:length(x)] .= sin.(x[1:3:length(x)])
  @test bsin!(y, x, 1:3:length(x)) == z
  @test sum(sin, x) ≈ sin_batch_sum(x)
  @test sum(sin, 1:9) ≈ sin_batch_sum(1:9)

  A = rand(200, 300)
  x = Vector{Float64}(undef, 300)
  rowsum_batch!(x, A)
  @test x ≈ vec(sum(A, dims = 1))

  let dest = zeros(10^3), src = (; a = (; b = rand(length(dest))))
    @test bar!(dest, src) == src.a.b
  end
  let src = rand(100), dest = (; src = similar(src))
    @test issue15!(dest, src).src == src
    @test issue16!(dest)
  end
  let dest = zeros(5, 10_000)
    issue17!(dest)
    @test dest == axes(dest, 1) .* axes(dest, 2)'
  end
  issue18!(ones(3))

  let x = rand(100), y = rand(100), dest1 = x .* y'
    dest0 = similar(dest1)
    # TODO: don't only thread outer
    @test issue25!(dest0, x, y) ≈ dest1
    fill!(dest0, NaN)
    @test issue25_but_with_strides!(dest0, x, y) ≈ dest1
  end
end

@testset "start and stop values" begin
  println("Running start and stop values tests...")
  function record_start_stop!((start_indices, end_indices), start, stop)
    start_indices[Threads.threadid()] = start
    end_indices[Threads.threadid()] = stop
    sleep(1) # if task completes two quickly, the mainthread will start stealing work back.
  end

  start_indices = zeros(Int, dynamic_thread_count())
  end_indices = zeros(Int, dynamic_thread_count())

  for range in [Threads.nthreads(), dynamic_thread_count(), 1000, 1001]
    start_indices .= 0
    end_indices .= 0
    batch(record_start_stop!, (range, dynamic_thread_count()), start_indices, end_indices)
    indices_test_per_thread = end_indices .- start_indices .+ 1
    acceptable_no_per_thread =
      [fld(range, dynamic_thread_count()), cld(range, dynamic_thread_count())]
    @test all(in.(indices_test_per_thread, Ref(acceptable_no_per_thread)))
    @test sum(indices_test_per_thread) == range
    @test length(unique(start_indices)) == dynamic_thread_count()
    @test length(unique(end_indices)) == dynamic_thread_count()
  end
end

@testset "!isbits args" begin
  println("Running !isbits args test...")
  # Struct and string
  mutable struct TestStruct
    vec::Vector{String}
  end
  vec_length = 20
  ts = TestStruct(["init" for i = 1:vec_length])
  update_text!((ts, val), start, stop) = ts.vec[start:stop] .= val
  batch(update_text!, (vec_length, Threads.nthreads()), ts, "new_val")
  @test all(ts.vec .== "new_val")


  struct Issue20
    values::Vector{Float64}
  end

  function issue20!(dest, cache)
    @batch for i in eachindex(dest)
      factor = -cache.a.values[i]
      dest[i] *= factor
    end
  end

  dest = ones(20)
  cache = (; a = Issue20(ones(length(dest))))
  issue20!(dest, cache)
  @test all(dest .≈ -1)
end

@testset "Non-UnitRange loops" begin
  u = randn(10, 100)
  x = view(u, 1:5, :)
  xref = 2 .* x
  @batch for i in eachindex(x)
    x[i] *= 2.0
  end
  arrayofarrays = collect(eachcol(x))
  @batch for x in arrayofarrays
    x .*= 2.0
  end
  @test reduce(hcat, arrayofarrays) == (xref .*= 2)
end

@testset "Generators and looping over array of functions" begin
  x = collect(1:12)
  y = zeros(6)
  issue108!(y, x)
  @test y == [sum(x[j] for j = 2i-oneunit(i):2i) for i = 1:6]

  functions = [x -> n * x for n = 1:3]
  data = rand(100)
  data1 = deepcopy(data)
  issue108_comment!(data, functions)
  for i in eachindex(data1)
    for f in functions
      data1[i] += f(data1[i])
    end
  end
  @test data == data1
end

println("Issue 245...")

import Polyester: splitloop, combine, NoLoop, @batch
using Test

struct LazyTree{T}
  t::T
end

Base.getindex(lt::LazyTree, row::Int) = lt.t[row]
Base.length(lt::LazyTree) = length(lt.t)
Base.lastindex(lt::LazyTree) = length(lt)
Base.eachindex(lt::LazyTree) = 1:lastindex(lt)
splitloop(e::Base.Iterators.Enumerate{LazyTree{T}}) where {T} =
  NoLoop(), eachindex(e.itr), e
combine(e::Iterators.Enumerate{LazyTree{T}}, ::NoLoop, j) where {T} = @inbounds e[j]
Base.getindex(e::Iterators.Enumerate{LazyTree{T}}, row::Int) where {T} =
  (row, first(iterate(e.itr, row)))
function Base.iterate(tree::LazyTree, idx = 1)
  idx > length(tree) && return nothing
  return tree.t[idx], idx + 1
end
Base.firstindex(e::Iterators.Enumerate{LazyTree{T}}) where {T} = firstindex(e.itr)
Base.lastindex(e::Iterators.Enumerate{LazyTree{T}}) where {T} = lastindex(e.itr)
Base.eachindex(e::Iterators.Enumerate{LazyTree{T}}) where {T} = eachindex(e.itr)

@testset "unROOT Enumerate interface" begin
  t = LazyTree(collect(2001:3000))
  for i = 1:3
    println("ITER $i")
    inds = [Vector{Int}() for _ = 1:Threads.nthreads()]
    @batch for (i, evt) in enumerate(t)
      push!(inds[Threads.threadid()], i)
    end
    @test sum([
      length(inds[i] ∩ inds[j]) for i = 1:length(inds), j = 1:length(inds) if j > i
    ]) == 0
  end
  evt = 5
end

@testset "not-specializing-on-type heuristics" begin
  allocated(f::F, args...) where {F} = @allocated f(args...)
  x = rand(10000)
  y = similar(x)
  allocated(issue116!, y, x)
  @test y ≈ exp.(x .+ 1.0)
  @test allocated(issue116!, y, x) == 0
end

@testset "threadlocal storage" begin
  local1 = let
    @batch threadlocal = 0 for i = 0:9
      threadlocal += 1
    end
    sum(threadlocal)
  end
  local2 = let
    @batch minbatch = 5 threadlocal = 0 for i = 0:9
      threadlocal += 1
    end
    sum(threadlocal)
  end
  local3 = let
    @batch per = core threadlocal = 0 for i = 0:9
      threadlocal += 1
    end
    sum(threadlocal)
  end
  local4 = let
    @batch per = core minbatch = 100 threadlocal = 0 for i = 0:9
      threadlocal += 1
    end
    sum(threadlocal)
  end
  myinitA() = 0
  local5 = let
    @batch threadlocal = myinitA() for i = 0:9
      threadlocal += 1
    end
    sum(threadlocal)
  end
  myinitB() = [0]
  local6 = let
    @batch threadlocal = myinitB() for i = 0:9
      threadlocal .+= 1
    end
    sum(threadlocal)[1]
  end
  @test local1 == local2 == local3 == local4 == local5 == local6
  # check that each thread has a separate init
  inits = let
    @batch threadlocal = rand() for i = 0:9
      threadlocal += 1
    end
    threadlocal
  end
  @test length(inits) == 1 || inits[1] != inits[end]
  # check that types are respected
  myinitD() = Float16(1.0)
  settingtype = let
    @batch threadlocal = myinitD()::Float16 for i = 0:9
      threadlocal += 1
    end
    threadlocal
  end
  @test eltype(settingtype) == Float16
  settingabstype = let
    @batch threadlocal = myinitD()::AbstractFloat for i = 0:9
      threadlocal += 1
    end
    threadlocal
  end
  @test eltype(settingabstype) <: AbstractFloat
  # check for excessive allocations
  function f()
    n = 1000
    @batch minbatch = 10 threadlocal = 1.0::Float64 for i = 1:n
      threadlocal += 1.0 / threadlocal
    end
    return threadlocal
  end
  allocated(f::F) where {F} = @allocated f()
  allocated(f)
  @test allocated(f) < 300 + 40 * Threads.nthreads()
end

@testset "reduction" begin
  local1 = let
    red = 0
    @batch reduction = (+, red) for i = 0:9
      red += 1
    end
    red
  end
  local2 = let
    red = 0
    @batch minbatch = 5 reduction = (+, red) for i = 0:9
      red += 1
    end
    red
  end
  local3 = let
    red = 0
    @batch per = core reduction = (+, red) for i = 0:9
      red += 1
    end
    red
  end
  local4 = let
    red = 0
    @batch per = core minbatch = 100 reduction = (+, red) for i = 0:9
      red += 1
    end
    red
  end
  local5 = let
    red = 0
    @batch minbatch = 100 stride = true reduction = (+, red) for i = 0:9
      red += 1
    end
    red
  end
  myinitA() = 0
  local6 = let
    red = myinitA()
    @batch reduction = (+, red) for i = 0:9
      red += 1
    end
    red
  end
  local7, local8 = let
    red = 0
    @batch minbatch = 100 stride = true reduction = (+, red) threadlocal = red for i = 0:9
      red += 1
      threadlocal += 1
    end
    red, threadlocal[1]
  end
  localsr = let # stride + reduction w/o minbatch
    red = 0
    @batch stride = true reduction = (+, red) for i = 0:9
      red += 1
    end
    red
  end
  @test local1 ==
        local2 ==
        local3 ==
        local4 ==
        local5 ==
        local6 ==
        local7 ==
        local8 ==
        localsr
  # check different operations
  local9 = let
    red = 1.0
    @batch reduction = (*, red) for i = 1:100
      red *= 4i^2 / (4i^2 - 1)
    end
    2red
  end
  @test local9 ≈ 2prod(4i^2 / (4i^2 - 1) for i = 1:100)
  # multiple reductions
  local10, local11, local12 = let
    red1 = 0
    red2 = 0
    red3 = 0
    @batch reduction = ((+, red1), (+, red2), (+, red3)) for i = 0:9
      red1 += 1
      red2 += 1
      red3 -= 1
    end
    red1, red2, red3
  end
  @test local10 == local11 == -local12
  # check for name interference with threadlocal (used to error on single threaded runs)
  function f()
    n = 1000
    threadlocal = 0
    @batch minbatch = 10 reduction = (+, threadlocal) for i = 1:n
      threadlocal += 1
    end
    return threadlocal
  end
  allocated(f::F) where {F} = @allocated f()
  inferred(f::F) where {F} =
    try
      @inferred f()
      true
    catch
      false
    end
  allocated(f)
  @test allocated(f) == 0
  @test inferred(f) == true
  # remaining supported operations
  arr = rand(10)
  local13, local14, local15, local16 = let arr = arr
    red1 = true
    red2 = false
    red3 = typemax(eltype(arr))
    red4 = typemin(eltype(arr))
    @batch reduction = ((&, red1), (|, red2), (min, red3), (max, red4)) for x in arr
      red1 &= x > 0.5
      red2 |= x > 0.5
      red3 = min(red3, x)
      red4 = max(red4, x)
    end
    red1, red2, red3, red4
  end
  @test (local13, local14, local15, local16) == (
    mapreduce(x -> x > 0.5, &, arr),
    mapreduce(x -> x > 0.5, |, arr),
    minimum(arr),
    maximum(arr),
  )
end

@testset "locks and refvalues" begin
  a = Ref(0.0)
  l = Threads.SpinLock()
  @time @batch for i = 1:1_000
    lock(l)
    try
      a[] += i
    finally
      unlock(l)
    end
  end
  @test a[] == sum(1:1_000)
end

@testset "gensym" begin
  # issue 59 (lack of gensym for keyword arguments)
  function f(; kw = 10)
    kw
  end
  buf = [0, 0]
  @batch for i = 1:2
    buf[i] = f(; kw = i)
  end
  @test buf == [1, 2]
  # issue 61
  function ff(buf, a)
    @batch for i = 1:2
      buf[i] = f(kw = i + a)
    end
  end
  ff(buf, 2)
  @test buf == [3, 4]
end

@testset "tuple and keywork unpacking" begin
  # issue 75
  buf = (1, (2, 3))
  dest = zeros(Int, 3)
  @batch for i = 1:2
    (a, (b, c)) = buf
    dest .= [a, b, c]
  end
  @test dest == [1, 2, 3]
end

@testset "gensym keywords with implicit name" begin
  # issue 78 (lack of support for keyword arguments using only variable names without `=`)

  f(a; b = 10.0, c = 100.0) = a + b + c

  buf = [0, 0]
  b = 0.0

  Threads.nthreads() == 1 && println("the issue arises only on multithreading runs")

  @batch for i = 1:2
    buf[i] = f(i; b, c = 0.0)
  end

  @test buf == [1, 2]
end

@testset "disable_polyester_threads" begin
  function inner(x, y, j)
    for i ∈ axes(x, 1)
      y[i, j] = sin(x[i, j])
    end
  end

  function inner_polyester(x, y, j)
    @batch for i ∈ axes(x, 1)
      y[i, j] = sin(x[i, j])
    end
  end

  function inner_thread(x, y, j)
    @threads for i ∈ axes(x, 1)
      y[i, j] = sin(x[i, j])
    end
  end

  function sequential_sequential(x, y)
    for j ∈ axes(x, 2)
      inner(x, y, j)
    end
  end

  function sequential_polyester(x, y)
    for j ∈ axes(x, 2)
      inner_polyester(x, y, j)
    end
  end

  function sequential_thread(x, y)
    for j ∈ axes(x, 2)
      inner_thread(x, y, j)
    end
  end

  function threads_of_polyester(x, y)
    @threads for j ∈ axes(x, 2)
      inner_polyester(x, y, j)
    end
  end

  function threads_of_polyester_inner_disable(x, y)
    @threads for j ∈ axes(x, 2)
      Polyester.disable_polyester_threads() do
        inner_polyester(x, y, j)
      end
    end
  end

  function threads_of_thread(x, y)
    @threads for j ∈ axes(x, 2)
      inner_thread(x, y, j)
    end
  end

  function threads_of_sequential(x, y)
    @threads for j ∈ axes(x, 2)
      inner(x, y, j)
    end
  end

  y = rand(10, 10) # (size of inner problem, size of outer problem)
  x = rand(size(y)...)
  inner(x, y, 1)
  good_y = copy(y)
  inner_polyester(x, y, 1)
  @assert good_y == y
  inner_thread(x, y, 1)
  @assert good_y == y
  sequential_sequential(x, y)
  good_y = copy(y)
  sequential_polyester(x, y)
  @assert good_y == y
  sequential_thread(x, y)
  @assert good_y == y
  threads_of_polyester(x, y)
  @assert good_y == y
  threads_of_polyester_inner_disable(x, y)
  @assert good_y == y
  disable_polyester_threads() do
    threads_of_polyester(x, y)
  end
  @assert good_y == y
  threads_of_sequential(x, y)
  @assert good_y == y
  threads_of_thread(x, y)
  @assert good_y == y
end

@testset "reset_threads!" begin
  sys_threads::Int = (Sys.CPU_THREADS)::Int
  runs_on_ci = parse(Bool, get(ENV, "GITHUB_ACTIONS", "false"))
  num_threads = min(Threads.nthreads(), sys_threads)

  function issue30_set!(dst)
    @batch per = thread for i in eachindex(dst)
      dst[i] = Threads.threadid()
    end
    return dst
  end

  dst = zeros(Int, 2 * max(num_threads, Threads.nthreads(), (Sys.CPU_THREADS)::Int))
  @test_nowarn issue30_set!(dst)
  if !(runs_on_ci && (Int == Int32))
    # There are issues on x86 systems in GitHub actions I don't understand
    @test sort!(unique(dst)) == 1:num_threads
  end

  function issue30_throw!(dst)
    @batch per = thread for i in eachindex(dst)
      dst[i] = Threads.threadid()
      if i > 1
        throw(DomainError("expected error"))
      end
    end
    return dst
  end

  # After throwing an error, the current implementation
  # disables multithreading
  @test_throws DomainError issue30_throw!(dst)
  @test_nowarn issue30_set!(dst)
  if dynamic_thread_count() <= num_threads
    @test sort!(unique(dst)) == 1:1
  end

  # Multithreading works again after resetting the threads
  @test_nowarn Polyester.reset_threads!()
  @test_nowarn issue30_set!(dst)
  if !(runs_on_ci && (Int == Int32))
    # There are issues on x86 systems in GitHub actions I don't understand
    @test sort!(unique(dst)) == 1:num_threads
  end
end

@testset "issue #119" begin
  # https://github.com/JuliaSIMD/Polyester.jl/issues/119
  function find_call_to_nthreads(expr)
    expr isa Expr || return false
    if expr.head === :call
      if Base.Threads.nthreads in expr.args
        return true
      end
    end
    return any(find_call_to_nthreads, expr.args)
  end

  expr = @macroexpand @batch for i = 1:100
    a[i] = i
  end

  @test find_call_to_nthreads(expr)
end


function dummy_broadcast!(x)
  @batch for i = 1:2
    a = (1,) .+ (1,)
    x[i] = only(a)
  end
end
let x = Vector{Float64}(undef, 2)
  dummy_broadcast!(x)
  @test x == fill(2.0, 2)
end

if VERSION ≥ v"1.6"
  println("Package tests complete. Running `Aqua` checks.")
  Aqua.test_all(Polyester; deps_compat = (check_extras = false,))
end

# S is a Val{Bool} indicating whether we will need to load the thread index
# C is a Tuple{...} containing the types of the reduction variables
struct BatchClosure{F,A,S,C}
  f::F
end
function (b::BatchClosure{F,A,S,C})(p::Ptr{UInt}) where {F,A,S,C}
  (offset, args) = ThreadingUtilities.load(p, A, 2 * sizeof(UInt))
  (offset, start) = ThreadingUtilities.load(p, UInt, offset)
  (offset, stop) = ThreadingUtilities.load(p, UInt, offset)
  if C === Tuple{} && !S
    b.f(args, (start + one(UInt)) % Int, stop % Int)
  elseif C === Tuple{} && S
    ((offset, i) = ThreadingUtilities.load(p, UInt, offset))
    b.f(args, (start + one(UInt)) % Int, stop % Int, i % Int)
  elseif C !== Tuple{} && !S
    ((offset, reducinits) = ThreadingUtilities.load(p, C, offset))
    reducres = b.f(args, (start + one(UInt)) % Int, stop % Int, reducinits)
    ThreadingUtilities.store!(p, reducres, offset)
  else
    ((offset, i) = ThreadingUtilities.load(p, UInt, offset))
    ((offset, reducinits) = ThreadingUtilities.load(p, C, offset))
    reducres = b.f(args, (start + one(UInt)) % Int, stop % Int, i % Int, reducinits)
    ThreadingUtilities.store!(p, reducres, offset)
  end
  ThreadingUtilities._atomic_store!(p, ThreadingUtilities.SPIN)
  nothing
end

@generated function batch_closure(f::F, args::A, ::Val{S}, reducinits::C) where {F,A,S,C}
  q = if Base.issingletontype(F)
    bc = BatchClosure{F,A,S,C}(F.instance)
    :(@cfunction($bc, Cvoid, (Ptr{UInt},)))
  else
    quote
      bc = BatchClosure{F,A,S,C}(f)
      @cfunction($(Expr(:$, :bc)), Cvoid, (Ptr{UInt},))
    end
  end
  return Expr(:block, Expr(:meta, :inline), q)
end
# @inline function batch_closure(f::F, args::A, ::Val{C}) where {F,A,C}
#   bc = BatchClosure{F,A,C}(f)
#   @cfunction($bc, Cvoid, (Ptr{UInt},))
# end

@inline function load_threadlocals(tid, argtup::A, ::Val{S}, reductup::C) where {A,S,C}
  p = ThreadingUtilities.taskpointer(tid)
  (offset, _) = ThreadingUtilities.load(p, UInt, sizeof(UInt))
  (offset, _) = ThreadingUtilities.load(p, A, offset)
  (offset, _) = ThreadingUtilities.load(p, UInt, offset)
  (offset, _) = ThreadingUtilities.load(p, UInt, offset)
  if S
    (offset, _) = ThreadingUtilities.load(p, UInt, offset)
  end
  (offset, _) = ThreadingUtilities.load(p, C, offset)
  (offset, reducvals) = ThreadingUtilities.load(p, C, offset)
  return reducvals
end

@inline function setup_batch!(
  p::Ptr{UInt},
  fptr::Ptr{Cvoid},
  argtup,
  start::UInt,
  stop::UInt,
)
  offset = ThreadingUtilities.store!(p, fptr, sizeof(UInt))
  offset = ThreadingUtilities.store!(p, argtup, offset)
  offset = ThreadingUtilities.store!(p, start, offset)
  offset = ThreadingUtilities.store!(p, stop, offset)
  nothing
end
@inline function setup_batch!(
  p::Ptr{UInt},
  fptr::Ptr{Cvoid},
  argtup,
  start::UInt,
  stop::UInt,
  i_or_reductup,
)
  offset = ThreadingUtilities.store!(p, fptr, sizeof(UInt))
  offset = ThreadingUtilities.store!(p, argtup, offset)
  offset = ThreadingUtilities.store!(p, start, offset)
  offset = ThreadingUtilities.store!(p, stop, offset)
  offset = ThreadingUtilities.store!(p, i_or_reductup, offset)
  nothing
end
@inline function setup_batch!(
  p::Ptr{UInt},
  fptr::Ptr{Cvoid},
  argtup,
  start::UInt,
  stop::UInt,
  i::UInt,
  reductup,
)
  offset = ThreadingUtilities.store!(p, fptr, sizeof(UInt))
  offset = ThreadingUtilities.store!(p, argtup, offset)
  offset = ThreadingUtilities.store!(p, start, offset)
  offset = ThreadingUtilities.store!(p, stop, offset)
  offset = ThreadingUtilities.store!(p, i, offset)
  offset = ThreadingUtilities.store!(p, reductup, offset)
  nothing
end
@inline function launch_batched_thread!(cfunc, tid, argtup, start, stop)
  fptr = Base.unsafe_convert(Ptr{Cvoid}, cfunc)
  ThreadingUtilities.launch(tid, fptr, argtup, start, stop) do p, fptr, argtup, start, stop
    setup_batch!(p, fptr, argtup, start, stop)
  end
end
@inline function launch_batched_thread!(cfunc, tid, argtup, start, stop, i_or_reductup)
  fptr = Base.unsafe_convert(Ptr{Cvoid}, cfunc)
  ThreadingUtilities.launch(
    tid,
    fptr,
    argtup,
    start,
    stop,
    i_or_reductup,
  ) do p, fptr, argtup, start, stop, i_or_reductup
    setup_batch!(p, fptr, argtup, start, stop, i_or_reductup)
  end
end
@inline function launch_batched_thread!(cfunc, tid, argtup, start, stop, i, reductup)
  fptr = Base.unsafe_convert(Ptr{Cvoid}, cfunc)
  ThreadingUtilities.launch(
    tid,
    fptr,
    argtup,
    start,
    stop,
    i,
    reductup,
  ) do p, fptr, argtup, start, stop, i, reductup
    setup_batch!(p, fptr, argtup, start, stop, i, reductup)
  end
end
_extract_params(::Type{T}) where {T<:Tuple} = T.parameters
_extract_params(::Type{NamedTuple{S,T}}) where {S,T<:Tuple} = T.parameters
push_tup!(x, ::Type{T}, t) where {T<:Tuple} = push!(x, t)
push_tup!(x, ::Type{NamedTuple{S,T}}, t) where {S,T<:Tuple} =
  push!(x, Expr(:call, Expr(:curly, :NamedTuple, S), t))

function add_var!(q, argtup, gcpres, ::Type{T}, argtupname, gcpresname, k) where {T}
  parg_k = Symbol(argtupname, :_, k)
  garg_k = Symbol(gcpresname, :_, k)
  if (T <: Tuple) # || (T <: NamedTuple) # NamedTuples do currently not work in all cases, see https://github.com/JuliaSIMD/Polyester.jl/issues/20
    push!(q.args, Expr(:(=), parg_k, Expr(:ref, argtupname, k)))
    t = Expr(:tuple)
    for (j, p) ∈ enumerate(_extract_params(T))
      add_var!(q, t, gcpres, p, parg_k, garg_k, j)
    end
    push_tup!(argtup.args, T, t)
  else
    push!(
      q.args,
      Expr(
        :(=),
        Expr(:tuple, parg_k, garg_k),
        Expr(:call, :object_and_preserve, Expr(:ref, argtupname, k)),
      ),
    )
    push!(argtup.args, parg_k)
    push!(gcpres.args, garg_k)
  end
end

@generated function _batch_no_reserve(
  f!::F,
  needtid::Val{S},
  reducops::Tuple{Vararg{Any,C}},
  reducinits::Tuple{Vararg{Any,C}},
  threadmask_tuple::NTuple{N},
  nthread_tuple,
  torelease_tuple,
  Nr::Int,
  Nd,
  ulen,
  args::Vararg{Any,K},
) where {F,K,N,S,C}
  q = quote
    $(Expr(:meta, :inline))
    # threads = UnsignedIteratorEarlyStop(threadmask, nthread)
    # threads_tuple = map(UnsignedIteratorEarlyStop, threadmask_tuple, nthread_tuple)
    # nthread_total = sum(nthread_tuple)
    Ndp = Nd + one(Nd)
  end
  C !== 0 && push!(q.args, quote
    @nexprs $C j -> RVAR_j = reducinits[j]
  end)
  launch_quote = if S
    if C === 0
      :(launch_batched_thread!(cfunc, tid, argtup, start, stop, tid % UInt))
    else
      :(launch_batched_thread!(cfunc, tid, argtup, start, stop, tid % UInt, reducinits))
    end
  else
    if C === 0
      :(launch_batched_thread!(cfunc, tid, argtup, start, stop))
    else
      :(launch_batched_thread!(cfunc, tid, argtup, start, stop, reducinits))
    end
  end
  f_quote = Expr(:call, :f!, :arguments, :((start + one(UInt)) % Int), :(ulen % Int))
  S && push!(f_quote.args, :((sum(nthread_tuple) + 1) % Int))
  C !== 0 && push!(f_quote.args, :reducinits)
  rem_quote = Expr(:block, :(thread_results = $f_quote))
  if C !== 0
    push!(
      rem_quote.args,
      :(@nexprs $C j -> RVAR_j = reducops[j](RVAR_j, thread_results[j])),
    )
  end
  update_retv = if C === 0
    Expr(:block)
  else
    quote
      thread_results = load_threadlocals(tid, argtup, needtid, reducinits)
      @nexprs $C j -> RVAR_j = reducops[j](RVAR_j, thread_results[j])
    end
  end
  ret_quote = Expr(:tuple)
  for j ∈ 1:C
    push!(ret_quote.args, Symbol("RVAR_", j))
  end

  block = quote
    start = zero(UInt)
    tid = 0x00000000
    for (threadmask, nthread) ∈ zip(threadmask_tuple, nthread_tuple)
      tm = mask(UnsignedIteratorEarlyStop(threadmask, nthread))
      i = 0x00000000
      while i ≠ nthread
        assume(tm ≠ zero(tm))
        tz = trailing_zeros(tm) % UInt32
        stop = start + ifelse(i < Nr, Ndp, Nd)
        i += 0x00000001
        tz += 0x00000001
        tid += tz
        tm >>>= tz
        $launch_quote
        start = stop
      end
      Nr = (Nr - nthread) % Int
    end
    $rem_quote
    tid = 0x00000000
    for (threadmask, nthread) ∈ zip(threadmask_tuple, nthread_tuple)
      tm = mask(UnsignedIteratorEarlyStop(threadmask, nthread))
      while tm ≠ zero(tm)
        # assume(tm ≠ zero(tm))
        tz = trailing_zeros(tm) % UInt32
        tz += 0x00000001
        tm >>>= tz
        tid += tz
        # @show tid, ThreadingUtilities._atomic_state(tid)
        ThreadingUtilities.wait(tid)
        $update_retv
      end
    end
    free_threads!(torelease_tuple)
    $ret_quote
  end
  gcpr = Expr(:gc_preserve, block, :cfunc)
  argt = Expr(:tuple)
  for k ∈ 1:K
    add_var!(q, argt, gcpr, args[k], :args, :gcp, k)
  end
  push!(
    q.args,
    :(arguments = $argt),
    :(argtup = Reference(arguments)),
    :(cfunc = batch_closure(f!, argtup, Val{$S}(), reducinits)),
    gcpr,
  )
  q
end

@inline function batch(
  f!::F,
  (len, nbatches)::Tuple{Vararg{Union{StaticInt,Integer},2}},
  args::Vararg{Any,K},
) where {F,K}

  batch(f!, Val{false}(), (), (), (len, nbatches), args...)
end

@inline function batch(
  f!::F,
  needtid::Val{S},
  reducops::Tuple{Vararg{Any,C}},
  reducinits::Tuple{Vararg{Any,C}},
  (len, nbatches)::Tuple{Vararg{Union{StaticInt,Integer},2}},
  args::Vararg{Any,K},
) where {F,K,C,S}
  len > 0 || return reducinits
  for var in reducinits
    @assert isbits(var)
  end
  if (nbatches > len)
    if (typeof(nbatches) !== typeof(len))
      return batch(f!, reducops, reducinits, needtid, (len, len), args...)
    end
    nbatches = len
  end
  ulen = len % UInt
  nbatches == 0 && @goto SERIAL
  threads, torelease = request_threads(nbatches - one(nbatches))
  nthreads = map(length, threads)
  nthread = sum(nthreads)
  if nthread % Int32 ≤ zero(Int32)
    @label SERIAL
    if S
      if C === 0
        f!(args, one(Int), ulen % Int, 1)
        return ()
      else
        reducres = f!(args, one(Int), ulen % Int, 1, reducinits)
        return reducres
      end
    else
      if C === 0
        f!(args, one(Int), ulen % Int)
        return ()
      else
        reducres = f!(args, one(Int), ulen % Int, reducinits)
        return reducres
      end
    end
  end
  nbatch = nthread + one(nthread)
  Nd = Base.udiv_int(ulen, nbatch % UInt) # reasonable for `ulen` to be ≥ 2^32
  Nr = (ulen - Nd * nbatch) % Int
  _batch_no_reserve(
    f!,
    needtid,
    reducops,
    reducinits,
    map(mask, threads),
    nthreads,
    torelease,
    Nr,
    Nd,
    ulen,
    args...,
  )
end
function batch(
  f!::F,
  (len, nbatches, reserve_per_worker)::Tuple{Vararg{Union{StaticInt,Integer},3}},
  args::Vararg{Any,K};
  needtid::Val{S} = Val(false),
  reducops::Tuple{Vararg{Any,C}} = (),
  reducinits::Tuple{Vararg{Any,C}} = (),
) where {F,K,C,S}
  batch(f!, needtid, reducops, reducinits, (len, nbatches), args...)
end
